AsArrayTypeDeserializer (Jackson JSON Processor)
Date: 2013-07-14

org.codehaus.jackson.map.jsontype.impl

## Class AsArrayTypeDeserializer

- java.lang.Object
- - org.codehaus.jackson.map.TypeDeserializer
  - - org.codehaus.jackson.map.jsontype.impl.TypeDeserializerBase
    - - org.codehaus.jackson.map.jsontype.impl.AsArrayTypeDeserializer

- Direct Known Subclasses:
    AsExternalTypeDeserializer, AsPropertyTypeDeserializer

      public class AsArrayTypeDeserializer
      extends TypeDeserializerBase

  Type deserializer used with `JsonTypeInfo.As.WRAPPER_ARRAY` inclusion mechanism. Simple since JSON structure used is always the same, regardless of structure used for actual value: wrapping is done using a 2-element JSON Array where type id is the first element, and actual object data as second element.
  Author:
    tatus

- - ### Field Summary

    - ### Fields inherited from class org.codehaus.jackson.map.jsontype.impl.TypeDeserializerBase

      `_baseType, _defaultImpl, _defaultImplDeserializer, _deserializers, _idResolver, _property`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `AsArrayTypeDeserializer(JavaType bt, TypeIdResolver idRes, BeanProperty property)` Deprecated.
    `AsArrayTypeDeserializer(JavaType bt, TypeIdResolver idRes, BeanProperty property, Class<?> defaultImpl)`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `protected String` | `_locateTypeId(JsonParser jp, DeserializationContext ctxt)`
    `Object` | `deserializeTypedFromAny(JsonParser jp, DeserializationContext ctxt)` Method called to let this type deserializer handle deserialization of "typed" object, when value itself may have been serialized using any kind of JSON value (Array, Object, scalar).
    `Object` | `deserializeTypedFromArray(JsonParser jp, DeserializationContext ctxt)` Method called when actual object is serialized as JSON Array.
    `Object` | `deserializeTypedFromObject(JsonParser jp, DeserializationContext ctxt)` Method called when actual object is serialized as JSON Object
    `Object` | `deserializeTypedFromScalar(JsonParser jp, DeserializationContext ctxt)` Method called to let this type deserializer handle deserialization of "typed" object, when value itself is serialized as a scalar JSON value (something other than Array or Object), regardless of Java type.
    `JsonTypeInfo.As` | `getTypeInclusion()` Accessor for type information inclusion method that deserializer uses; indicates how type information is (expected to be) embedded in JSON input.

    - ### Methods inherited from class org.codehaus.jackson.map.jsontype.impl.TypeDeserializerBase

      `_findDefaultImplDeserializer, _findDeserializer, baseTypeName, getDefaultImpl, getPropertyName, getTypeIdResolver, toString`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Constructor Detail

    - #### AsArrayTypeDeserializer

          @Deprecated
          public AsArrayTypeDeserializer(JavaType bt,
                                            TypeIdResolver idRes,
                                            BeanProperty property)

      Deprecated.

    - #### AsArrayTypeDeserializer

          public AsArrayTypeDeserializer(JavaType bt,
                                 TypeIdResolver idRes,
                                 BeanProperty property,
                                 Class<?> defaultImpl)

  - ### Method Detail

    - #### getTypeInclusion

          public JsonTypeInfo.As getTypeInclusion()

      Description copied from class: `TypeDeserializer`
      Accessor for type information inclusion method that deserializer uses; indicates how type information is (expected to be) embedded in JSON input.
      Specified by:
        `getTypeInclusion` in class `TypeDeserializerBase`

    - #### deserializeTypedFromArray

          public Object deserializeTypedFromArray(JsonParser jp,
                                         DeserializationContext ctxt)
                                           throws IOException,
                                                  JsonProcessingException

      Method called when actual object is serialized as JSON Array.
      Specified by:
        `deserializeTypedFromArray` in class `TypeDeserializer`
      Throws:
        `IOException`
        `JsonProcessingException`

    - #### deserializeTypedFromObject

          public Object deserializeTypedFromObject(JsonParser jp,
                                          DeserializationContext ctxt)
                                            throws IOException,
                                                   JsonProcessingException

      Method called when actual object is serialized as JSON Object
      Specified by:
        `deserializeTypedFromObject` in class `TypeDeserializer`
      Throws:
        `IOException`
        `JsonProcessingException`

    - #### deserializeTypedFromScalar

          public Object deserializeTypedFromScalar(JsonParser jp,
                                          DeserializationContext ctxt)
                                            throws IOException,
                                                   JsonProcessingException

      Description copied from class: `TypeDeserializer`
      Method called to let this type deserializer handle deserialization of "typed" object, when value itself is serialized as a scalar JSON value (something other than Array or Object), regardless of Java type. Method needs to figure out intended polymorphic type, locate `JsonDeserializer` to use, and call it with JSON data to deserializer (which does not contain type information).
      Specified by:
        `deserializeTypedFromScalar` in class `TypeDeserializer`
      Throws:
        `IOException`
        `JsonProcessingException`

    - #### deserializeTypedFromAny

          public Object deserializeTypedFromAny(JsonParser jp,
                                       DeserializationContext ctxt)
                                         throws IOException,
                                                JsonProcessingException

      Description copied from class: `TypeDeserializer`
      Method called to let this type deserializer handle deserialization of "typed" object, when value itself may have been serialized using any kind of JSON value (Array, Object, scalar). Should only be called if JSON serialization is polymorphic (not Java type); for example when using JSON node representation, or "untyped" Java object (which may be Map, Collection, wrapper/primitive etc).
      Specified by:
        `deserializeTypedFromAny` in class `TypeDeserializer`
      Throws:
        `IOException`
        `JsonProcessingException`

    - #### _locateTypeId

          protected final String _locateTypeId(JsonParser jp,
                             DeserializationContext ctxt)
                                        throws IOException,
                                               JsonProcessingException

      Throws:
        `IOException`
        `JsonProcessingException`